{% comment %}
    <!--
    This snippet spits out the HTML navigation derived from the front matter settings in your markdown files.
    https://gist.github.com/dominikwilkowski/c7d916c9b36e4eebbc90

    Usage:
        {% include navigation.liquid %}

    Return:
        HTML direct output

    Required:
        Front matter needs this element:
            weight: "010.030.020"
    -->

<!--
pages = site.content
prefix: relative_path
level: 1
 -->
{% endcomment %}

{% comment %}<!-- current page -->{% endcomment %}
{% assign urlparts = page.url | split: "/" %}
{% assign urlpartslength = urlparts | size %}

{% comment %}<!-- handle case for index.html that has page.url '/' -->{% endcomment %}
{% if urlpartslength != 0 %}

    {% assign urlpartslength = urlpartslength | minus:1 %}
    {% assign urlname = urlparts.last %}
    {% assign urlprefix = page.url | replace: 'index.html' %}
    {% assign urlprefix = page.url | replace: '.html' %}

    {% assign area = urlparts[1] %}
    {% assign area = area | replace: urlname %}

    {% comment %}<!-- root folder as id for collection -->{% endcomment %}
    {% assign docs = site[area]  %}

    <ul class="navigation nav nav-list" id="menu">
        {% for file in docs %}

            {% assign path = file.relative_path %}
            {% assign parts = path | split: "/" %}
            {% assign partslength = parts | size %}
            {% assign partslength = partslength | minus:1 %}
            {% assign name = parts.last %}
            {% assign prefix = file.relative_path | parts.last %}

            {% comment %}<!-- prefix check: is valid -->{% endcomment %}
            {% assign rest = file.url | replace: urlprefix %}
            {% assign valid = false %}

            {% comment %}<!-- subfolder -->{% endcomment %}
            {% if rest != file.url%}
                {% assign valid = true %}
                {% comment %}<!-- SF -->{% endcomment %}
            {% endif %}

            {% comment %}<!-- subfolder -->{% endcomment %}
            {% if urlpartslength > 1 and urlpartslength == partslength and true == false%}
                {% comment %}<!-- EXP -->{% endcomment %}
                {% assign valid = true %}
            {% endif %}

            {% comment %}<!-- level where collapse/expand functionality starts -->{% endcomment %}
            {% if partslength <= site.navlevel %}
                {% comment %}<!-- CONF -->{% endcomment %}
                {% assign valid = true %}
            {% endif %}


            {% comment %}<!-- same level -->{% endcomment %}
            {% assign tmp = file.url | split: "/" %}
            {% assign prefix = file.url | replace: tmp.last %}
            {% assign rest = page.url | replace: prefix %}
            {% if valid == false and urlpartslength > partslength% and rest != page.url %}
                {% comment %}<!-- LVL -->{% endcomment %}
                {% assign valid = true %}
            {% endif %}

            {% comment %}<!-- expand only next sublevel not all sublevel  -->{% endcomment %}
            {% if valid == true and urlpartslength < partslength %}
                {% comment %}<!-- NOTSUB -->{% endcomment %}
                {% assign valid = false %}
            {% endif %}


            {% comment %}<!-- fallback: is self -->{% endcomment %}
            {% if valid == false and page.url == file.url %}
                {% comment %}<!-- SELF -->{% endcomment %}
                {% assign valid = true %}
            {% endif %}

            {% comment %}<!-- hide entry for index.md  -->{% endcomment %}
            {% if valid == true and name == 'index.md' %}
                {% comment %}<!-- IDX -->{% endcomment %}
                {% assign valid = false %}
            {% endif %}

            {% comment %}<!-- filename contains '.hidden.'  -->{% endcomment %}
            {% assign tmp = name | split: '.hidden.' %}
            {% assign tmpsize = tmp | size %}
            {% if valid == true and tmpsize > 1 %}
                {% comment %}<!-- HIDDEN -->{% endcomment %}
                {% assign valid = false %}
            {% endif %}

            {% comment %}<!-- non valid will be hidden -->{% endcomment %}
            <li class="target level-{{ partslength }}{% if valid != true %} hidden{% endif %}{% if page.url == file.url %} active{% endif %}" data-title="{{ file.title }}" data-description="{{ file.description | replace:'"', "'" }}">
                <a class="link" href="{{site.baseurl}}{{ file.url }}">
                    <i class="link-icon fa fa-fw {{ file.icon }}" aria-hidden="true"></i>
                    <span class="link-title"> {{ file.title }} </span>
                </a>
            </li>
        {% endfor %}
    </ul>
{% endif %}
